#ifndef _TEST_H_
#define _TEST_H_

#include <crtdbg.h>


// The following macros set and clear, respectively, given bits
// of the C runtime library debug flag, as specified by a bitmask.
#ifdef   _DEBUG
#define  SET_CRT_DEBUG_FIELD(a) \
            _CrtSetDbgFlag((a) | _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#define  CLEAR_CRT_DEBUG_FIELD(a) \
            _CrtSetDbgFlag(~(a) & _CrtSetDbgFlag(_CRTDBG_REPORT_FLAG))
#else
#define  SET_CRT_DEBUG_FIELD(a)   ((void) 0)
#define  CLEAR_CRT_DEBUG_FIELD(a) ((void) 0)
#endif


typedef void (*FNTest)();
extern bool status;


void RunTest(FNTest fn, char* name=0);
void OutputHeading( const char * explanation );
void BeginTesting();
void EndTesting();


#define TEST(b) {bool ev = b; _ASSERT(ev); if(!ev) status=false;}


#endif